# Command Line Text Processing

Learn about various commands available for common and exotic text processing needs. Examples have been tested on GNU/Linux - there'd be syntax/feature variations with other distributions, consult their respective `man` pages for details.

---

:warning: :warning: I'm no longer actively working on this repo. Instead, I've converted existing chapters into ebooks (see [ebook section](#ebooks) below for links), available under the same license. These ebooks are better formatted, updated for newer versions of the software, includes exercises, solutions, etc. Since all the chapters have been converted, I'm archiving this repo.

---

<br>

## Ebooks

Individual online ebooks with better formatting, explanations, exercises, solutions, etc:

* [GNU grep and ripgrep](https://learnbyexample.github.io/learn_gnugrep_ripgrep/)
* [GNU sed](https://learnbyexample.github.io/learn_gnused/)
* [GNU awk](https://learnbyexample.github.io/learn_gnuawk/)
* [Ruby one-liners cookbook](https://learnbyexample.github.io/learn_ruby_oneliners/)
* [Perl one-liners cookbook](https://learnbyexample.github.io/learn_perl_oneliners/)
* [Command line text processing with GNU Coreutils](https://learnbyexample.github.io/cli_text_processing_coreutils/)
* [Computing from the Command Line](https://learnbyexample.github.io/cli-computing/)

See https://learnbyexample.github.io/books/ for links to pdf/epub versions and other ebooks.

<br>

## Chapters

As mentioned earlier, I'm no longer actively working on these chapters:

* [Cat, Less, Tail and Head](./tail_less_cat_head.md)
    * cat, less, tail, head, Text Editors
* [GNU grep](./gnu_grep.md)
* [GNU sed](./gnu_sed.md)
* [GNU awk](./gnu_awk.md)
* [Perl the swiss knife](./perl_the_swiss_knife.md)
* [Ruby one liners](./ruby_one_liners.md)
* [Sorting stuff](./sorting_stuff.md)
    * sort, uniq, comm, shuf
* [Restructure text](./restructure_text.md)
    * paste, column, pr, fold
* [Whats the difference](./whats_the_difference.md)
    * cmp, diff
* [Wheres my file](./wheres_my_file.md)
* [File attributes](./file_attributes.md)
    * wc, du, df, touch, file
* [Miscellaneous](./miscellaneous.md)
    * cut, tr, basename, dirname, xargs, seq

<br>

## Webinar recordings

Recorded couple of videos based on content in the chapters, not sure if I'll do more:

* [Using the sort command](https://www.youtube.com/watch?v=qLfAwwb5vGs)
* [Using uniq and comm](https://www.youtube.com/watch?v=uAb2kxA2TyQ)

<br>

## Exercises

Check out [exercises](./exercises) directory to solve practice questions on `grep`, right from the command line itself.

<br>

## Contributing

* Please [open an issue](https://github.com/learnbyexample/Command-line-text-processing/issues) for typos or bugs
    * As this repo is no longer actively worked upon, **please do not submit pull requests**
* Share the repo with friends/colleagues, on social media, etc to help reach other learners
* In case you need to reach me, mail me at `echo 'yrneaolrknzcyr.arg@tznvy.pbz' | tr 'a-z' 'n-za-m'` or send a DM via [twitter](https://twitter.com/learn_byexample)

<br>

## Acknowledgements

* [unix.stackexchange](https://unix.stackexchange.com/) and [stackoverflow](https://stackoverflow.com/) - for getting answers to pertinent questions as well as sharpening skills by understanding and answering questions
* Forums like [Linux users](https://www.linkedin.com/groups/65688), [/r/commandline/](https://www.reddit.com/r/commandline/), [/r/linux/](https://www.reddit.com/r/linux/), [/r/ruby/](https://www.reddit.com/r/ruby/), [news.ycombinator](https://news.ycombinator.com/news), [devup](http://devup.in/) and others for valuable feedback (especially spotting mistakes) and encouragement
* See [wikipedia entry 'Roses Are Red'](https://en.wikipedia.org/wiki/Roses_Are_Red) for `poem.txt` used as sample text input file

<br>

## License

This work is licensed under a [Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License](https://creativecommons.org/licenses/by-nc-sa/4.0/)
